--- CMakeLists.txt.orig
+++ CMakeLists.txt
@@ -93,20 +93,29 @@
 set(THIS_IS_A_RELEASE OFF)   # only related to version name, no further implications.
 if(NOT ${THIS_IS_A_RELEASE})
     # Get the current working branch
-    execute_process(
-        COMMAND git rev-parse --abbrev-ref HEAD
-        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
-        OUTPUT_VARIABLE GIT_BRANCH
-        OUTPUT_STRIP_TRAILING_WHITESPACE
-    )
+    # was this info set in the CMake commandline?
+    if(NOT GIT_BRANCH)
+        # no: try to find it
+        execute_process(
+            COMMAND git rev-parse --abbrev-ref HEAD
+            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+            OUTPUT_VARIABLE GIT_BRANCH
+            OUTPUT_STRIP_TRAILING_WHITESPACE
+            OUTPUT_QUIET ERROR_QUIET
+        )
+    endif(NOT GIT_BRANCH)
 
     # Get the latest abbreviated commit hash of the working branch
-    execute_process(
-        COMMAND git log -1 --format=%h
-        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
-        OUTPUT_VARIABLE GIT_COMMIT_HASH
-        OUTPUT_STRIP_TRAILING_WHITESPACE
-    )
+    # was this info set in the CMake commandline?
+    if(NOT GIT_COMMIT_HASH)
+        execute_process(
+            COMMAND git log -1 --format=%h
+            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+            OUTPUT_VARIABLE GIT_COMMIT_HASH
+            OUTPUT_STRIP_TRAILING_WHITESPACE
+            OUTPUT_QUIET ERROR_QUIET
+        )
+    endif(NOT GIT_COMMIT_HASH)
 endif(NOT ${THIS_IS_A_RELEASE})
 
 set(VERSION_INFO_MAJOR_VERSION 0)
